AWS IoT Device SDK C++ v2: Aws::Iotsecuretunneling::SecureTunnelBuilder Class Reference

AWS IoT Device SDK C++ v2 1.14.0 AWS IoT Device SDK C++ v2

Public Member Functions | Friends | List of all members
Aws::Iotsecuretunneling::SecureTunnelBuilder Class Referencefinal

`#include <SecureTunnel.h>`

## Public Member Functions
| SecureTunnelBuilder (Crt::Allocator *allocator, Aws::Crt::Io::ClientBootstrap &clientBootstrap, const Aws::Crt::Io::SocketOptions &socketOptions, const std::string &accessToken, aws_secure_tunneling_local_proxy_mode localProxyMode, const std::string &endpointHost)
SecureTunnelBuilder & | WithRootCa (const std::string &rootCa)
SecureTunnelBuilder & | WithHttpClientConnectionProxyOptions (const Aws::Crt::Http::HttpClientConnectionProxyOptions &httpClientConnectionProxyOptions)
SecureTunnelBuilder & | WithOnConnectionComplete (OnConnectionComplete onConnectionComplete)
SecureTunnelBuilder & | WithOnConnectionShutdown (OnConnectionShutdown onConnectionShutdown)
SecureTunnelBuilder & | WithOnSendDataComplete (OnSendDataComplete onSendDataComplete)
SecureTunnelBuilder & | WithOnDataReceive (OnDataReceive onDataReceive)
SecureTunnelBuilder & | WithOnStreamStart (OnStreamStart onStreamStart)
SecureTunnelBuilder & | WithOnStreamReset (OnStreamReset onStreamReset)
SecureTunnelBuilder & | WithOnSessionReset (OnSessionReset onSessionReset)
std::shared_ptr< SecureTunnel > | Build () noexcept

## Friends
class | SecureTunnel

## Constructor & Destructor Documentation

## ◆ SecureTunnelBuilder()

Aws::Iotsecuretunneling::SecureTunnelBuilder::SecureTunnelBuilder | ( | Crt::Allocator * | allocator,
|  | Aws::Crt::Io::ClientBootstrap & | clientBootstrap,
|  | const Aws::Crt::Io::SocketOptions & | socketOptions,
|  | const std::string & | accessToken,
|  | aws_secure_tunneling_local_proxy_mode | localProxyMode,
|  | const std::string & | endpointHost
| ) |  |

Constructor arguments are the minimum required to create a secure tunnel

## Member Function Documentation

## ◆ Build()

std::shared_ptr< SecureTunnel > Aws::Iotsecuretunneling::SecureTunnelBuilder::Build | ( |  | ) |
| noexcept

Will return a shared pointer to a new SecureTunnel that countains a new aws_secure_tunnel that is generated using the set members of SecureTunnelBuilder. On failure, the shared_ptr will contain a nullptr, call Aws::Crt::LastErrorOrUnknown(); to get the reason for failure.

## ◆ WithHttpClientConnectionProxyOptions()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithHttpClientConnectionProxyOptions | ( | const Aws::Crt::Http::HttpClientConnectionProxyOptions & | httpClientConnectionProxyOptions | ) |

## ◆ WithOnConnectionComplete()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithOnConnectionComplete | ( | OnConnectionComplete | onConnectionComplete | ) |

## ◆ WithOnConnectionShutdown()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithOnConnectionShutdown | ( | OnConnectionShutdown | onConnectionShutdown | ) |

## ◆ WithOnDataReceive()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithOnDataReceive | ( | OnDataReceive | onDataReceive | ) |

## ◆ WithOnSendDataComplete()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithOnSendDataComplete | ( | OnSendDataComplete | onSendDataComplete | ) |

## ◆ WithOnSessionReset()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithOnSessionReset | ( | OnSessionReset | onSessionReset | ) |

## ◆ WithOnStreamReset()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithOnStreamReset | ( | OnStreamReset | onStreamReset | ) |

## ◆ WithOnStreamStart()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithOnStreamStart | ( | OnStreamStart | onStreamStart | ) |

## ◆ WithRootCa()

SecureTunnelBuilder & Aws::Iotsecuretunneling::SecureTunnelBuilder::WithRootCa | ( | const std::string & | rootCa | ) |

Optional members

## Friends And Related Function Documentation

## ◆ SecureTunnel

friend class SecureTunnel
| friend

The documentation for this class was generated from the following files:

- secure_tunneling/include/aws/iotsecuretunneling/SecureTunnel.h
- secure_tunneling/source/SecureTunnel.cpp